--- net/minecraft/src/NetClientHandler.java
+++ net/minecraft/src/NetClientHandler.java
@@ -6,7 +6,11 @@
 import java.net.InetAddress;
 import java.net.Socket;
 import java.net.URL;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
 import java.util.Random;
+
 import net.minecraft.client.Minecraft;
 
 public class NetClientHandler extends NetHandler {
@@ -28,6 +32,8 @@
 		if(!this.disconnected) {
 			this.netManager.processReadPackets();
 		}
+
+		this.netManager.wakeThreads();
 	}
 
 	public void handleLogin(Packet1Login var1) {
@@ -36,19 +42,21 @@
 		this.worldClient.multiplayerWorld = true;
 		this.mc.changeWorld1(this.worldClient);
 		this.mc.displayGuiScreen(new GuiDownloadTerrain(this));
+		this.mc.thePlayer.entityID = var1.protocolVersion;
 	}
 
 	public void handlePickupSpawn(Packet21PickupSpawn var1) {
 		double var2 = (double)var1.xPosition / 32.0D;
 		double var4 = (double)var1.yPosition / 32.0D;
 		double var6 = (double)var1.zPosition / 32.0D;
-		EntityItem var8 = new EntityItem(this.worldClient, var2, var4, var6, new ItemStack(var1.itemID, var1.count));
+		EntityItem var8 = new EntityItem(this.worldClient, var2, var4, var6, new ItemStack(var1.itemID, var1.count, var1.itemDamage));
 		var8.motionX = (double)var1.rotation / 128.0D;
 		var8.motionY = (double)var1.pitch / 128.0D;
 		var8.motionZ = (double)var1.roll / 128.0D;
 		var8.serverPosX = var1.xPosition;
 		var8.serverPosY = var1.yPosition;
 		var8.serverPosZ = var1.zPosition;
+		var8.entityID = var1.entityId;
 		this.worldClient.addEntityToWorld(var1.entityId, var8);
 	}
 
@@ -57,20 +65,35 @@
 		double var4 = (double)var1.yPosition / 32.0D;
 		double var6 = (double)var1.zPosition / 32.0D;
 		Object var8 = null;
-		if(var1.type == 10) {
+		
+		switch (var1.type) {
+		case 10:
 			var8 = new EntityMinecart(this.worldClient, var2, var4, var6, 0);
-		}
-
-		if(var1.type == 11) {
+			break;
+		case 11:
 			var8 = new EntityMinecart(this.worldClient, var2, var4, var6, 1);
-		}
-
-		if(var1.type == 12) {
+			break;
+		case 12:
 			var8 = new EntityMinecart(this.worldClient, var2, var4, var6, 2);
-		}
-
-		if(var1.type == 1) {
+			break;
+		case 60:
+			var8 = new EntityArrow(this.worldClient, var2, var4, var6);
+			break;
+		case 61:
+			var8 = new EntitySnowball(this.worldClient, var2, var4, var6);
+			break;
+		case 1:
 			var8 = new EntityBoat(this.worldClient, var2, var4, var6);
+			break;
+		case 50:
+			var8 = new EntityTNTPrimed(this.worldClient, var2, var4, var6);
+			break;
+		case 70:
+			var8 = new EntityFallingSand(this.worldClient, var2, var4, var6, Block.sand.blockID);
+			break;
+		case 71:
+			var8 = new EntityFallingSand(this.worldClient, var2, var4, var6, Block.gravel.blockID);
+			break;
 		}
 
 		if(var8 != null) {
@@ -81,6 +104,36 @@
 			((Entity)var8).rotationPitch = 0.0F;
 			((Entity)var8).entityID = var1.entityId;
 			this.worldClient.addEntityToWorld(var1.entityId, (Entity)var8);
+			
+			if (var1.field_28044_i > 0) {
+				if(var1.type == 60) {
+					Entity var9 = this.getEntityByID(var1.field_28044_i);
+					if(var9 instanceof EntityLiving) {
+						((EntityArrow)var8).shootingEntity = (EntityLiving)var9;
+					}
+				}
+				
+				((Entity)var8).setVelocity((double)var1.field_28047_e / 8000.0D, (double)var1.field_28046_f / 8000.0D, (double)var1.field_28045_g / 8000.0D);
+			}
+		}
+	}
+
+	public void func_21146_a(Packet25EntityPainting var1) {
+		EntityPainting var2 = new EntityPainting(this.worldClient, var1.xPosition, var1.yPosition, var1.zPosition, var1.direction, var1.title);
+		this.worldClient.addEntityToWorld(var1.entityId, var2);
+	}
+	
+	public void func_6498_a(Packet28EntityVelocity var1) {
+		Entity var2 = this.getEntityByID(var1.entityId);
+		if(var2 != null) {
+			var2.setVelocity((double)var1.motionX / 8000.0D, (double)var1.motionY / 8000.0D, (double)var1.motionZ / 8000.0D);
+		}
+	}
+
+	public void func_21148_a(Packet40EntityMetadata var1) {
+		Entity var2 = this.getEntityByID(var1.entityId);
+		if(var2 != null && var1.func_21047_b() != null) {
+			var2.getDataWatcher().updateWatchedObjectsFromList(var1.func_21047_b());
 		}
 
 	}
@@ -92,14 +145,14 @@
 		float var8 = (float)(var1.rotation * 360) / 256.0F;
 		float var9 = (float)(var1.pitch * 360) / 256.0F;
 		EntityOtherPlayerMP var10 = new EntityOtherPlayerMP(this.mc.theWorld, var1.name);
-		var10.serverPosX = var1.xPosition;
-		var10.serverPosY = var1.yPosition;
-		var10.serverPosZ = var1.zPosition;
+		var10.prevPosX = var10.lastTickPosX = (double)(var10.serverPosX = var1.xPosition);
+		var10.prevPosY = var10.lastTickPosY = (double)(var10.serverPosY = var1.yPosition);
+		var10.prevPosZ = var10.lastTickPosZ = (double)(var10.serverPosZ = var1.zPosition);
 		int var11 = var1.currentItem;
 		if(var11 == 0) {
 			var10.inventory.mainInventory[var10.inventory.currentItem] = null;
 		} else {
-			var10.inventory.mainInventory[var10.inventory.currentItem] = new ItemStack(var11);
+			var10.inventory.mainInventory[var10.inventory.currentItem] = new ItemStack(var11, 1, 0);
 		}
 
 		var10.setPositionAndRotation(var2, var4, var6, var8, var9);
@@ -113,7 +166,7 @@
 			var2.serverPosY = var1.yPosition;
 			var2.serverPosZ = var1.zPosition;
 			double var3 = (double)var2.serverPosX / 32.0D;
-			double var5 = (double)var2.serverPosY / 32.0D;
+			double var5 = (double)var2.serverPosY / 32.0D + 1.0D / 64.0D;
 			double var7 = (double)var2.serverPosZ / 32.0D;
 			float var9 = (float)(var1.yaw * 360) / 256.0F;
 			float var10 = (float)(var1.pitch * 360) / 256.0F;
@@ -201,7 +254,7 @@
 
 	public void handleMapChunk(Packet51MapChunk var1) {
 		this.worldClient.invalidateBlockReceiveRegion(var1.xPosition, var1.yPosition, var1.zPosition, var1.xPosition + var1.xSize - 1, var1.yPosition + var1.ySize - 1, var1.zPosition + var1.zSize - 1);
-		this.worldClient.setChunkData(var1.xPosition, var1.yPosition, var1.zPosition, var1.xSize, var1.ySize, var1.zSize, var1.chunkData);
+		this.worldClient.setChunkData(var1.xPosition, var1.yPosition, var1.zPosition, var1.xSize, var1.ySize, var1.zSize, var1.chunk);
 	}
 
 	public void handleBlockChange(Packet53BlockChange var1) {
@@ -215,13 +268,20 @@
 		this.mc.displayGuiScreen(new GuiConnectFailed("Disconnected by server", var1.reason));
 	}
 
-	public void handleErrorMessage(String var1) {
+	public void handleErrorMessage(String var1, Object[] var2) {
 		if(!this.disconnected) {
 			this.disconnected = true;
 			this.mc.changeWorld1((World)null);
 			this.mc.displayGuiScreen(new GuiConnectFailed("Connection lost", var1));
 		}
 	}
+	
+	public void func_28117_a(Packet var1) {
+		if(!this.disconnected) {
+			this.netManager.addToSendQueue(var1);
+			this.netManager.func_28142_c();
+		}
+	}
 
 	public void addToSendQueue(Packet var1) {
 		if(!this.disconnected) {
@@ -230,7 +290,7 @@
 	}
 
 	public void handleCollect(Packet22Collect var1) {
-		EntityItem var2 = (EntityItem)this.worldClient.getEntityByID(var1.collectedEntityId);
+		Entity var2 = this.worldClient.getEntityByID(var1.collectedEntityId);
 		Object var3 = (EntityLiving)this.worldClient.getEntityByID(var1.collectorEntityId);
 		if(var3 == null) {
 			var3 = this.mc.thePlayer;
@@ -244,47 +304,34 @@
 
 	}
 
-	public void handleBlockItemSwitch(Packet16BlockItemSwitch var1) {
-		Entity var2 = this.worldClient.getEntityByID(var1.entityId);
-		if(var2 != null) {
-			EntityPlayer var3 = (EntityPlayer)var2;
-			int var4 = var1.id;
-			if(var4 == 0) {
-				var3.inventory.mainInventory[var3.inventory.currentItem] = null;
-			} else {
-				var3.inventory.mainInventory[var3.inventory.currentItem] = new ItemStack(var4);
-			}
-
-		}
-	}
-
 	public void handleChat(Packet3Chat var1) {
 		this.mc.ingameGUI.addChatMessage(var1.message);
 	}
 
-	public void handleArmAnimation(Packet18ArmAnimation var1) {
+	public void handleArmAnimation(Packet18Animation var1) {
 		Entity var2 = this.worldClient.getEntityByID(var1.entityId);
 		if(var2 != null) {
-			EntityPlayer var3 = (EntityPlayer)var2;
-			var3.swingItem();
+			EntityPlayer var3;
+			if(var1.animate == 1) {
+				var3 = (EntityPlayer)var2;
+				var3.swingItem();
+			} else if(var1.animate == 2) {
+				var2.performHurtAnimation();
+			}
 		}
-	}
-
-	public void handleAddToInventory(Packet17AddToInventory var1) {
-		this.mc.thePlayer.inventory.addItemStackToInventory(new ItemStack(var1.itemID, var1.count, var1.itemDamage));
 	}
 
 	public void handleHandshake(Packet2Handshake var1) {
 		if(var1.username.equals("-")) {
-			this.addToSendQueue(new Packet1Login(this.mc.session.username, "Password", 2));
+			this.addToSendQueue(new Packet1Login(this.mc.session.username, 1984));
 		} else {
 			try {
-				URL var2 = new URL("http://www.minecraft.net/game/joinserver.jsp?user=" + this.mc.session.username + "&sessionId=" + this.mc.session.sessionId + "&serverId=" + var1.username);
+				URL var2 = new URL("https://session.minecraft.net/game/joinserver.jsp?user=" + this.mc.session.username + "&sessionId=" + this.mc.session.sessionId + "&serverId=" + var1.username);
 				BufferedReader var3 = new BufferedReader(new InputStreamReader(var2.openStream()));
 				String var4 = var3.readLine();
 				var3.close();
 				if(var4.equalsIgnoreCase("ok")) {
-					this.addToSendQueue(new Packet1Login(this.mc.session.username, "Password", 2));
+					this.addToSendQueue(new Packet1Login(this.mc.session.username, 1984));
 				} else {
 					this.netManager.networkShutdown("Failed to login: " + var4);
 				}
@@ -298,6 +345,7 @@
 
 	public void disconnect() {
 		this.disconnected = true;
+		this.netManager.wakeThreads();
 		this.netManager.networkShutdown("Closed");
 	}
 
@@ -311,43 +359,215 @@
 		var10.serverPosX = var1.xPosition;
 		var10.serverPosY = var1.yPosition;
 		var10.serverPosZ = var1.zPosition;
+		var10.entityID = var1.entityId;
 		var10.setPositionAndRotation(var2, var4, var6, var8, var9);
 		var10.isAIEnabled = true;
 		this.worldClient.addEntityToWorld(var1.entityId, var10);
+		List var11 = var1.getMetadata();
+		if(var11 != null) {
+			var10.getDataWatcher().updateWatchedObjectsFromList(var11);
+		}
 	}
 
 	public void handleUpdateTime(Packet4UpdateTime var1) {
 		this.mc.theWorld.setWorldTime(var1.time);
 	}
 
-	public void handlePlayerInventory(Packet5PlayerInventory var1) {
-		EntityPlayerSP var2 = this.mc.thePlayer;
-		if(var1.inventoryType == -1) {
-			var2.inventory.mainInventory = var1.inventory;
-		}
-
-		if(var1.inventoryType == -2) {
-			var2.inventory.craftingInventory = var1.inventory;
-		}
-
-		if(var1.inventoryType == -3) {
-			var2.inventory.armorInventory = var1.inventory;
-		}
-
-	}
-
-	public void handleComplexEntity(Packet59ComplexEntity var1) {
-		TileEntity var2 = this.worldClient.getBlockTileEntity(var1.xCoord, var1.yCoord, var1.zCoord);
-		if(var2 != null) {
-			var2.readFromNBT(var1.tileEntityNBT);
-			this.worldClient.markBlocksDirty(var1.xCoord, var1.yCoord, var1.zCoord, var1.xCoord, var1.yCoord, var1.zCoord);
-		}
-
-	}
-
 	public void handleSpawnPosition(Packet6SpawnPosition var1) {
 		this.worldClient.spawnX = var1.xPosition;
 		this.worldClient.spawnY = var1.yPosition;
 		this.worldClient.spawnZ = var1.zPosition;
+	}
+	
+	public void func_6497_a(Packet39AttachEntity var1) {
+		Object var2 = this.getEntityByID(var1.entityId);
+		Entity var3 = this.getEntityByID(var1.vehicleEntityId);
+		if(var1.entityId == this.mc.thePlayer.entityID) {
+			var2 = this.mc.thePlayer;
+		}
+
+		if(var2 != null) {
+			((Entity)var2).mountEntity(var3);
+		}
+	}
+
+	public void func_9447_a(Packet38EntityStatus var1) {
+		Entity var2 = this.getEntityByID(var1.entityId);
+		if(var2 != null) {
+			var2.handleHealthUpdate(var1.entityStatus);
+		}
+
+	}
+
+	private Entity getEntityByID(int var1) {
+		return (Entity)(var1 == this.mc.thePlayer.entityID ? this.mc.thePlayer : this.worldClient.getEntityByID(var1));
+	}
+
+	public void handleHealth(Packet8UpdateHealth var1) {
+		this.mc.thePlayer.setHealth(var1.healthMP);
+	}
+
+	public void func_9448_a(Packet9Respawn var1) {
+		this.posUpdated = false;
+		this.worldClient = new WorldClient(this);
+		this.worldClient.multiplayerWorld = true;
+		this.mc.changeWorld1(this.worldClient);
+		this.mc.displayGuiScreen(new GuiDownloadTerrain(this));
+
+		this.mc.respawn();
+	}
+
+	public void func_12245_a(Packet60Explosion var1) {
+		Explosion var2 = new Explosion(this.mc.theWorld, (Entity)null, var1.explosionX, var1.explosionY, var1.explosionZ, var1.explosionSize);
+		var2.destroyedBlockPositions = var1.destroyedBlockPositions;
+		var2.doExplosionB(true);
+	}
+
+	public void func_20087_a(Packet100OpenWindow var1) {
+		if(var1.inventoryType == 0) {
+			InventoryBasic var2 = new InventoryBasic(var1.windowTitle, var1.slotsCount);
+			this.mc.thePlayer.displayGUIChest(var2);
+			this.mc.thePlayer.craftingInventory.windowId = var1.windowId;
+		} else if(var1.inventoryType == 2) {
+			TileEntityFurnace var3 = new TileEntityFurnace();
+			this.mc.thePlayer.displayGUIFurnace(var3);
+			this.mc.thePlayer.craftingInventory.windowId = var1.windowId;
+		} else if(var1.inventoryType == 1) {
+			EntityPlayerSP var5 = this.mc.thePlayer;
+			this.mc.thePlayer.displayWorkbenchGUI(MathHelper.floor_double(var5.posX), MathHelper.floor_double(var5.posY), MathHelper.floor_double(var5.posZ));
+			this.mc.thePlayer.craftingInventory.windowId = var1.windowId;
+		}
+
+	}
+
+	public void func_20088_a(Packet103SetSlot var1) {
+		if(var1.windowId == -1) {
+			this.mc.thePlayer.inventory.setItemStack(var1.myItemStack);
+		} else if(var1.windowId == 0 && var1.itemSlot >= 36 && var1.itemSlot < 45) {
+			ItemStack var2 = this.mc.thePlayer.inventorySlots.getSlot(var1.itemSlot).getStack();
+			if(var1.myItemStack != null && (var2 == null || var2.stackSize < var1.myItemStack.stackSize)) {
+				var1.myItemStack.animationsToGo = 5;
+			}
+
+			this.mc.thePlayer.inventorySlots.putStackInSlot(var1.itemSlot, var1.myItemStack);
+		} else if(var1.windowId == this.mc.thePlayer.craftingInventory.windowId) {
+			this.mc.thePlayer.craftingInventory.putStackInSlot(var1.itemSlot, var1.myItemStack);
+		}
+
+	}
+
+	public void func_20089_a(Packet106Transaction var1) {
+		Container var2 = null;
+		if(var1.windowId == 0) {
+			var2 = this.mc.thePlayer.inventorySlots;
+		} else if(var1.windowId == this.mc.thePlayer.craftingInventory.windowId) {
+			var2 = this.mc.thePlayer.craftingInventory;
+		}
+
+		if(var2 != null) {
+			if(var1.field_20030_c) {
+				var2.func_20113_a(var1.field_20028_b);
+			} else {
+				var2.func_20110_b(var1.field_20028_b);
+				this.addToSendQueue(new Packet106Transaction(var1.windowId, var1.field_20028_b, true));
+			}
+		}
+
+	}
+
+	public void func_20094_a(Packet104WindowItems var1) {
+		if(var1.windowId == 0) {
+			this.mc.thePlayer.inventorySlots.putStacksInSlots(var1.itemStack);
+		} else if(var1.windowId == this.mc.thePlayer.craftingInventory.windowId) {
+			this.mc.thePlayer.craftingInventory.putStacksInSlots(var1.itemStack);
+		}
+
+	}
+
+	public void handleSignUpdate(Packet130UpdateSign var1) {
+		if(this.mc.theWorld.blockExists(var1.xPosition, var1.yPosition, var1.zPosition)) {
+			TileEntity var2 = this.mc.theWorld.getBlockTileEntity(var1.xPosition, var1.yPosition, var1.zPosition);
+			if(var2 instanceof TileEntitySign) {
+				TileEntitySign var3 = (TileEntitySign)var2;
+
+				for(int var4 = 0; var4 < 4; ++var4) {
+					var3.signText[var4] = var1.signLines[var4];
+				}
+
+				var3.onInventoryChanged();
+			}
+		}
+
+	}
+
+	public void func_20090_a(Packet105UpdateProgressbar var1) {
+		this.registerPacket(var1);
+		if(this.mc.thePlayer.craftingInventory != null && this.mc.thePlayer.craftingInventory.windowId == var1.windowId) {
+			this.mc.thePlayer.craftingInventory.func_20112_a(var1.progressBar, var1.progressBarValue);
+		}
+
+	}
+
+	public void handlePlayerInventory(Packet5PlayerInventory var1) {
+		Entity var2 = this.getEntityByID(var1.entityID);
+		if(var2 != null) {
+			var2.outfitWithItem(var1.slot, var1.itemID, var1.itemDamage);
+		}
+
+	}
+
+	public void func_20092_a(Packet101CloseWindow var1) {
+		this.mc.thePlayer.closeScreen();
+	}
+	
+	public void func_28115_a(Packet61DoorChange var1) {
+		this.mc.theWorld.func_28106_e(var1.field_28050_a, var1.field_28053_c, var1.field_28052_d, var1.field_28051_e, var1.field_28049_b);
+	}
+	
+	public void handle62Sound(Packet62Sound packet) {
+		if (!this.mc.options.accept62) return;
+		this.mc.renderGlobal.playSound(packet.sound, packet.locX, packet.locY, packet.locZ, packet.f, packet.f1);
+	}
+
+	@Override
+	public void handleParticle(Packet63WorldParticles packet) {
+		//System.out.println("Particle !!!! " + packet.getType() + ", " + packet.getCount() + ", " + packet.getX() + ", " + packet.getY() + ", " + packet.getZ());
+		for (int i = 0; i < packet.getCount(); i++) {
+			double d = this.rand.nextGaussian() * packet.getVelocityX();
+			double e = this.rand.nextGaussian() * packet.getVelocityY();
+			double f = this.rand.nextGaussian() * packet.getVelocityZ();
+			double g = this.rand.nextGaussian() * packet.getVelocityScale();
+			double h = this.rand.nextGaussian() * packet.getVelocityScale();
+			double j = this.rand.nextGaussian() * packet.getVelocityScale();
+			this.mc.renderGlobal.spawnParticle(packet.getType(), packet.getX() + d, packet.getY() + e, packet.getZ() + f, g, h, j);
+		}
+	}
+
+	private Map<Integer, Integer> miningSoundTimer = new HashMap<>();
+	@Override
+	public void handle55BlockBreakAnimation(Packet55BlockBreakAnimation packet) {
+		int x = packet.getX();
+		int y = packet.getY();
+		int z = packet.getZ();
+		this.mc.renderGlobal.updateBlockMiningProgress(packet.getPlayerId(), x, y, z, packet.getProgress());
+
+		int timer = this.miningSoundTimer.getOrDefault(packet.getPlayerId(), 0);
+		
+		Block block = Block.blocksList[this.worldClient.getBlockId(x, y, z)];
+		if (block != null && packet.getProgress() >= 0 && y >= 0 && timer % 3 == 0) {
+			this.mc.sndManager.playSound(block.stepSound.getStepSound(), x + 0.5F, y + 0.5F, z + 0.5F, (block.stepSound.getVolume() + 1.0F) / 8.0F, block.stepSound.getPitch() * 0.5F);
+		}
+		
+		if (packet.getProgress() != 255) {
+			this.miningSoundTimer.put(packet.getPlayerId(), ++timer);
+		} else {
+			this.miningSoundTimer.remove(packet.getPlayerId());
+		}
+		
+		
+	}
+
+	public boolean isServerHandler() {
+		return false;
 	}
 }
--- /dev/null
+++ net/minecraft/src/ItemWool.java
@@ -1,0 +1,20 @@
+package net.minecraft.src;
+
+public class ItemWool extends ItemBlock {
+
+	public ItemWool(int i) {
+		super(i);
+		this.setMaxDamage(0);
+		this.setHasSubtypes(true);
+	}
+
+	@Override
+	public int getSprite(int metadata) {
+		return Block.cloth.getBlockTextureFromSideAndMetadata(2, BlockWool.getBlockMetadataForItemMetadata(metadata));
+	}
+
+	@Override
+	public int getPlacedBlockMetadata(int metadata) {
+		return metadata;
+	}
+}
--- net/minecraft/src/ItemBow.java
+++ net/minecraft/src/ItemBow.java
@@ -9,7 +9,9 @@
 	public ItemStack onItemRightClick(ItemStack var1, World var2, EntityPlayer var3) {
 		if(var3.inventory.consumeInventoryItem(Item.arrow.shiftedIndex)) {
 			var2.playSoundAtEntity(var3, "random.bow", 1.0F, 1.0F / (rand.nextFloat() * 0.4F + 0.8F));
-			var2.spawnEntityInWorld(new EntityArrow(var2, var3));
+			if (!var2.multiplayerWorld) {
+			    var2.spawnEntityInWorld(new EntityArrow(var2, var3));
+			}
 		}
 
 		return var1;
